<template>
  <div class="map-container">
    <div id="map"></div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import 'leaflet/dist/leaflet.css';
import redMarkerIcon from 'src/assets/marker-icon-2x-red.png';
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
import L from 'leaflet';

export default defineComponent({
  props: {
    title: {
      type: String,
      required: true,
    },
    latitude: {
      type: Number,
      required: true,
    },
    longitude: {
      type: Number,
      required: true,
    },
  },
  name: 'MiniMap',
  data() {
    return {
      mapDiv: null,
    };
  },
  mounted() {
    this.mapDiv = L.map('map', { zoomControl: false }).setView(
      [this.latitude, this.longitude],
      10
    );
    L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      attribution:
        '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>',
    }).addTo(this.mapDiv);
    this.addMarker();
  },

  methods: {
    getIconMarker: function () {
      return L.icon({
        iconUrl: redMarkerIcon,
        iconSize: [25, 41],
        iconAnchor: [12, 41],
        popupAnchor: [1, -34],
      });
    },
    addMarker: function () {
      const redIcon = this.getIconMarker();
      const marker = L.marker([this.latitude, this.longitude], {
        icon: redIcon,
      }).addTo(this.mapDiv);
      marker.bindPopup(this.title);
      marker.on('click', this.onClick);
    },
    onClick: function (e) {
      const popup = e.target.getPopup();
      popup.getContent();
    },
  },
});
</script>
